#pragma once

#include "ros_bridge/include/JsonMethodes.h"
#include "ros_bridge/include/MessageBaseClass.h"
#include "ros_bridge/include/GenericMessages.h"

#include <QGeoCoordinate>
#include <QObject>


typedef ROSBridge::MessageBaseClass ROSMsg;
typedef ROSBridge::GenericMessages::GeographicMsgs::GeoPoint ROSGeoPoint;
namespace MsgGroups = ROSBridge::MessageGroups;
class GeoPoint3D : public QObject, public ROSGeoPoint
{
    Q_OBJECT
public:
    typedef MsgGroups::GeoPointGroup Group;

    GeoPoint3D(QObject *parent = nullptr);
    GeoPoint3D(double latitude,
               double longitude,
               double altitude,
               QObject *parent = nullptr);
    GeoPoint3D(const GeoPoint3D& p,
               QObject *parent = nullptr);
    GeoPoint3D(const ROSGeoPoint& p,
               QObject *parent = nullptr);
    GeoPoint3D(const QGeoCoordinate& p,
               QObject *parent = nullptr);

    virtual GeoPoint3D *Clone() const override;
    GeoPoint3D &operator=(const GeoPoint3D&p);
    GeoPoint3D &operator=(const QGeoCoordinate&p);

};


